/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage
 * @generated
 */
public interface ParameterdependenciesFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ParameterdependenciesFactory eINSTANCE = edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Influenced Variable Reference</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Influenced Variable Reference</em>'.
	 * @generated
	 */
	InfluencedVariableReference createInfluencedVariableReference();

	/**
	 * Returns a new object of class '<em>Shadow Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Shadow Parameter</em>'.
	 * @generated
	 */
	ShadowParameter createShadowParameter();

	/**
	 * Returns a new object of class '<em>Dependency Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Dependency Relationship</em>'.
	 * @generated
	 */
	DependencyRelationship createDependencyRelationship();

	/**
	 * Returns a new object of class '<em>Correlation Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Correlation Relationship</em>'.
	 * @generated
	 */
	CorrelationRelationship createCorrelationRelationship();

	/**
	 * Returns a new object of class '<em>Component Instance Reference</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Component Instance Reference</em>'.
	 * @generated
	 */
	ComponentInstanceReference createComponentInstanceReference();

	/**
	 * Returns a new object of class '<em>Scope Set</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Scope Set</em>'.
	 * @generated
	 */
	ScopeSet createScopeSet();

	/**
	 * Returns a new object of class '<em>Scope</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Scope</em>'.
	 * @generated
	 */
	Scope createScope();

	/**
	 * Returns a new object of class '<em>Service Input Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Service Input Parameter</em>'.
	 * @generated
	 */
	ServiceInputParameter createServiceInputParameter();

	/**
	 * Returns a new object of class '<em>External Call Return Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>External Call Return Parameter</em>'.
	 * @generated
	 */
	ExternalCallReturnParameter createExternalCallReturnParameter();

	/**
	 * Returns a new object of class '<em>External Call Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>External Call Parameter</em>'.
	 * @generated
	 */
	ExternalCallParameter createExternalCallParameter();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	ParameterdependenciesPackage getParameterdependenciesPackage();

} //ParameterdependenciesFactory
