/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Characterization;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ComponentInstanceReference;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Correlation Relationship</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CorrelationRelationshipImpl#getSources <em>Sources</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CorrelationRelationshipImpl#getDestination <em>Destination</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CorrelationRelationshipImpl#getSourceComponentInstanceReferences <em>Source Component Instance References</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CorrelationRelationshipImpl#getDestinationComponentInstanceReference <em>Destination Component Instance Reference</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CorrelationRelationshipImpl extends RelationshipImpl implements CorrelationRelationship {
	/**
	 * The cached value of the '{@link #getSources() <em>Sources</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSources()
	 * @generated
	 * @ordered
	 */
	protected EList<InfluencingParameter> sources;

	/**
	 * The cached value of the '{@link #getDestination() <em>Destination</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDestination()
	 * @generated
	 * @ordered
	 */
	protected InfluencingParameter destination;

	/**
	 * The cached value of the '{@link #getSourceComponentInstanceReferences() <em>Source Component Instance References</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceComponentInstanceReferences()
	 * @generated
	 * @ordered
	 */
	protected EList<ComponentInstanceReference> sourceComponentInstanceReferences;

	/**
	 * The cached value of the '{@link #getDestinationComponentInstanceReference() <em>Destination Component Instance Reference</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDestinationComponentInstanceReference()
	 * @generated
	 * @ordered
	 */
	protected ComponentInstanceReference destinationComponentInstanceReference;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CorrelationRelationshipImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ParameterdependenciesPackage.Literals.CORRELATION_RELATIONSHIP;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<InfluencingParameter> getSources() {
		if (sources == null) {
			sources = new EObjectResolvingEList<InfluencingParameter>(InfluencingParameter.class, this, ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__SOURCES);
		}
		return sources;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InfluencingParameter getDestination() {
		if (destination != null && destination.eIsProxy()) {
			InternalEObject oldDestination = (InternalEObject)destination;
			destination = (InfluencingParameter)eResolveProxy(oldDestination);
			if (destination != oldDestination) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION, oldDestination, destination));
			}
		}
		return destination;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InfluencingParameter basicGetDestination() {
		return destination;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDestination(InfluencingParameter newDestination) {
		InfluencingParameter oldDestination = destination;
		destination = newDestination;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION, oldDestination, destination));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ComponentInstanceReference> getSourceComponentInstanceReferences() {
		if (sourceComponentInstanceReferences == null) {
			sourceComponentInstanceReferences = new EObjectContainmentEList<ComponentInstanceReference>(ComponentInstanceReference.class, this, ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__SOURCE_COMPONENT_INSTANCE_REFERENCES);
		}
		return sourceComponentInstanceReferences;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentInstanceReference getDestinationComponentInstanceReference() {
		return destinationComponentInstanceReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDestinationComponentInstanceReference(ComponentInstanceReference newDestinationComponentInstanceReference, NotificationChain msgs) {
		ComponentInstanceReference oldDestinationComponentInstanceReference = destinationComponentInstanceReference;
		destinationComponentInstanceReference = newDestinationComponentInstanceReference;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION_COMPONENT_INSTANCE_REFERENCE, oldDestinationComponentInstanceReference, newDestinationComponentInstanceReference);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDestinationComponentInstanceReference(ComponentInstanceReference newDestinationComponentInstanceReference) {
		if (newDestinationComponentInstanceReference != destinationComponentInstanceReference) {
			NotificationChain msgs = null;
			if (destinationComponentInstanceReference != null)
				msgs = ((InternalEObject)destinationComponentInstanceReference).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION_COMPONENT_INSTANCE_REFERENCE, null, msgs);
			if (newDestinationComponentInstanceReference != null)
				msgs = ((InternalEObject)newDestinationComponentInstanceReference).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION_COMPONENT_INSTANCE_REFERENCE, null, msgs);
			msgs = basicSetDestinationComponentInstanceReference(newDestinationComponentInstanceReference, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION_COMPONENT_INSTANCE_REFERENCE, newDestinationComponentInstanceReference, newDestinationComponentInstanceReference));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__SOURCE_COMPONENT_INSTANCE_REFERENCES:
				return ((InternalEList<?>)getSourceComponentInstanceReferences()).basicRemove(otherEnd, msgs);
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION_COMPONENT_INSTANCE_REFERENCE:
				return basicSetDestinationComponentInstanceReference(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__SOURCES:
				return getSources();
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION:
				if (resolve) return getDestination();
				return basicGetDestination();
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__SOURCE_COMPONENT_INSTANCE_REFERENCES:
				return getSourceComponentInstanceReferences();
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION_COMPONENT_INSTANCE_REFERENCE:
				return getDestinationComponentInstanceReference();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__SOURCES:
				getSources().clear();
				getSources().addAll((Collection<? extends InfluencingParameter>)newValue);
				return;
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION:
				setDestination((InfluencingParameter)newValue);
				return;
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__SOURCE_COMPONENT_INSTANCE_REFERENCES:
				getSourceComponentInstanceReferences().clear();
				getSourceComponentInstanceReferences().addAll((Collection<? extends ComponentInstanceReference>)newValue);
				return;
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION_COMPONENT_INSTANCE_REFERENCE:
				setDestinationComponentInstanceReference((ComponentInstanceReference)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__SOURCES:
				getSources().clear();
				return;
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION:
				setDestination((InfluencingParameter)null);
				return;
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__SOURCE_COMPONENT_INSTANCE_REFERENCES:
				getSourceComponentInstanceReferences().clear();
				return;
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION_COMPONENT_INSTANCE_REFERENCE:
				setDestinationComponentInstanceReference((ComponentInstanceReference)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__SOURCES:
				return sources != null && !sources.isEmpty();
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION:
				return destination != null;
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__SOURCE_COMPONENT_INSTANCE_REFERENCES:
				return sourceComponentInstanceReferences != null && !sourceComponentInstanceReferences.isEmpty();
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP__DESTINATION_COMPONENT_INSTANCE_REFERENCE:
				return destinationComponentInstanceReference != null;
		}
		return super.eIsSet(featureID);
	}

} //CorrelationRelationshipImpl
