/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ComponentInternalBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.LoopAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.LoopIterationCount;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.LoopIterationCountDistribution;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Loop Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.LoopActionImpl#getLoopBodyBehavior <em>Loop Body Behavior</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.LoopActionImpl#getLoopIterationCount <em>Loop Iteration Count</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class LoopActionImpl extends AbstractActionImpl implements LoopAction {
	/**
	 * The cached value of the '{@link #getLoopBodyBehavior() <em>Loop Body Behavior</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLoopBodyBehavior()
	 * @generated
	 * @ordered
	 */
	protected ComponentInternalBehavior loopBodyBehavior;

	/**
	 * The cached value of the '{@link #getLoopIterationCount() <em>Loop Iteration Count</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLoopIterationCount()
	 * @generated
	 * @ordered
	 */
	protected LoopIterationCount loopIterationCount;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LoopActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServicebehaviorPackage.Literals.LOOP_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentInternalBehavior getLoopBodyBehavior() {
		return loopBodyBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLoopBodyBehavior(ComponentInternalBehavior newLoopBodyBehavior, NotificationChain msgs) {
		ComponentInternalBehavior oldLoopBodyBehavior = loopBodyBehavior;
		loopBodyBehavior = newLoopBodyBehavior;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.LOOP_ACTION__LOOP_BODY_BEHAVIOR, oldLoopBodyBehavior, newLoopBodyBehavior);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLoopBodyBehavior(ComponentInternalBehavior newLoopBodyBehavior) {
		if (newLoopBodyBehavior != loopBodyBehavior) {
			NotificationChain msgs = null;
			if (loopBodyBehavior != null)
				msgs = ((InternalEObject)loopBodyBehavior).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ServicebehaviorPackage.LOOP_ACTION__LOOP_BODY_BEHAVIOR, null, msgs);
			if (newLoopBodyBehavior != null)
				msgs = ((InternalEObject)newLoopBodyBehavior).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ServicebehaviorPackage.LOOP_ACTION__LOOP_BODY_BEHAVIOR, null, msgs);
			msgs = basicSetLoopBodyBehavior(newLoopBodyBehavior, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.LOOP_ACTION__LOOP_BODY_BEHAVIOR, newLoopBodyBehavior, newLoopBodyBehavior));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LoopIterationCount getLoopIterationCount() {
		return loopIterationCount;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLoopIterationCount(LoopIterationCount newLoopIterationCount, NotificationChain msgs) {
		LoopIterationCount oldLoopIterationCount = loopIterationCount;
		loopIterationCount = newLoopIterationCount;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.LOOP_ACTION__LOOP_ITERATION_COUNT, oldLoopIterationCount, newLoopIterationCount);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLoopIterationCount(LoopIterationCount newLoopIterationCount) {
		if (newLoopIterationCount != loopIterationCount) {
			NotificationChain msgs = null;
			if (loopIterationCount != null)
				msgs = ((InternalEObject)loopIterationCount).eInverseRemove(this, ServicebehaviorPackage.LOOP_ITERATION_COUNT__LOOP_ACTION, LoopIterationCount.class, msgs);
			if (newLoopIterationCount != null)
				msgs = ((InternalEObject)newLoopIterationCount).eInverseAdd(this, ServicebehaviorPackage.LOOP_ITERATION_COUNT__LOOP_ACTION, LoopIterationCount.class, msgs);
			msgs = basicSetLoopIterationCount(newLoopIterationCount, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.LOOP_ACTION__LOOP_ITERATION_COUNT, newLoopIterationCount, newLoopIterationCount));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.LOOP_ACTION__LOOP_ITERATION_COUNT:
				if (loopIterationCount != null)
					msgs = ((InternalEObject)loopIterationCount).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ServicebehaviorPackage.LOOP_ACTION__LOOP_ITERATION_COUNT, null, msgs);
				return basicSetLoopIterationCount((LoopIterationCount)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.LOOP_ACTION__LOOP_BODY_BEHAVIOR:
				return basicSetLoopBodyBehavior(null, msgs);
			case ServicebehaviorPackage.LOOP_ACTION__LOOP_ITERATION_COUNT:
				return basicSetLoopIterationCount(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServicebehaviorPackage.LOOP_ACTION__LOOP_BODY_BEHAVIOR:
				return getLoopBodyBehavior();
			case ServicebehaviorPackage.LOOP_ACTION__LOOP_ITERATION_COUNT:
				return getLoopIterationCount();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServicebehaviorPackage.LOOP_ACTION__LOOP_BODY_BEHAVIOR:
				setLoopBodyBehavior((ComponentInternalBehavior)newValue);
				return;
			case ServicebehaviorPackage.LOOP_ACTION__LOOP_ITERATION_COUNT:
				setLoopIterationCount((LoopIterationCount)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.LOOP_ACTION__LOOP_BODY_BEHAVIOR:
				setLoopBodyBehavior((ComponentInternalBehavior)null);
				return;
			case ServicebehaviorPackage.LOOP_ACTION__LOOP_ITERATION_COUNT:
				setLoopIterationCount((LoopIterationCount)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.LOOP_ACTION__LOOP_BODY_BEHAVIOR:
				return loopBodyBehavior != null;
			case ServicebehaviorPackage.LOOP_ACTION__LOOP_ITERATION_COUNT:
				return loopIterationCount != null;
		}
		return super.eIsSet(featureID);
	}

} //LoopActionImpl
