/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.predictionset;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.Repository;

import edu.kit.ipd.descartes.mm.deployment.Deployment;

import edu.kit.ipd.descartes.mm.resourcelandscape.DistributedDataCenter;

import edu.kit.ipd.descartes.mm.workload.Workload;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Prediction Set</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getWorkloadModel <em>Workload Model</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getDeploymentModel <em>Deployment Model</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getSystemModel <em>System Model</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getRepositoryModel <em>Repository Model</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getResourcelandscapeModel <em>Resourcelandscape Model</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSetPackage#getPredictionSet()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='SystemModelReferencedByDeploymentModelAndWorkloadModelMustBeTheSame'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot SystemModelReferencedByDeploymentModelAndWorkloadModelMustBeTheSame='systemModel = deploymentModel.system'"
 * @generated
 */
public interface PredictionSet extends EObject {
	/**
	 * Returns the value of the '<em><b>Workload Model</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Workload Model</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Workload Model</em>' reference.
	 * @see #setWorkloadModel(Workload)
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSetPackage#getPredictionSet_WorkloadModel()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	Workload getWorkloadModel();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getWorkloadModel <em>Workload Model</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Workload Model</em>' reference.
	 * @see #getWorkloadModel()
	 * @generated
	 */
	void setWorkloadModel(Workload value);

	/**
	 * Returns the value of the '<em><b>Deployment Model</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deployment Model</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deployment Model</em>' reference.
	 * @see #setDeploymentModel(Deployment)
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSetPackage#getPredictionSet_DeploymentModel()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	Deployment getDeploymentModel();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getDeploymentModel <em>Deployment Model</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Deployment Model</em>' reference.
	 * @see #getDeploymentModel()
	 * @generated
	 */
	void setDeploymentModel(Deployment value);

	/**
	 * Returns the value of the '<em><b>System Model</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>System Model</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>System Model</em>' reference.
	 * @see #setSystemModel(edu.kit.ipd.descartes.mm.applicationlevel.system.System)
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSetPackage#getPredictionSet_SystemModel()
	 * @model required="true" derived="true" ordered="false"
	 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot derivation='workloadModel.system'"
	 * @generated
	 */
	edu.kit.ipd.descartes.mm.applicationlevel.system.System getSystemModel();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getSystemModel <em>System Model</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>System Model</em>' reference.
	 * @see #getSystemModel()
	 * @generated
	 */
	void setSystemModel(edu.kit.ipd.descartes.mm.applicationlevel.system.System value);

	/**
	 * Returns the value of the '<em><b>Repository Model</b></em>' reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.applicationlevel.repository.Repository}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Repository Model</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Repository Model</em>' reference list.
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSetPackage#getPredictionSet_RepositoryModel()
	 * @model required="true" derived="true" ordered="false"
	 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot derivation='systemModel->collect(r : _\'/resource/edu.kit.ipd.descartes.mm.applicationlevel/model/system.ecore\'::system::System | assemblyContexts.encapsulatedComponent.repository)->asSet()'"
	 * @generated
	 */
	EList<Repository> getRepositoryModel();

	/**
	 * Returns the value of the '<em><b>Resourcelandscape Model</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resourcelandscape Model</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resourcelandscape Model</em>' reference.
	 * @see #setResourcelandscapeModel(DistributedDataCenter)
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSetPackage#getPredictionSet_ResourcelandscapeModel()
	 * @model required="true" derived="true" ordered="false"
	 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot derivation='deploymentModel.targetResourceLandscape'"
	 * @generated
	 */
	DistributedDataCenter getResourcelandscapeModel();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.predictionset.PredictionSet#getResourcelandscapeModel <em>Resourcelandscape Model</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Resourcelandscape Model</em>' reference.
	 * @see #getResourcelandscapeModel()
	 * @generated
	 */
	void setResourcelandscapeModel(DistributedDataCenter value);

} // PredictionSet
