/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.workload;

import edu.kit.ipd.descartes.core.CorePackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.workload.WorkloadFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface WorkloadPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "workload";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.descartes-research.net/metamodel/workload/0.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "workload";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	WorkloadPackage eINSTANCE = edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl.init();

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.WorkloadImpl <em>Workload</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getWorkload()
	 * @generated
	 */
	int WORKLOAD = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>System</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD__SYSTEM = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Usage Scenarios</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD__USAGE_SCENARIOS = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Workload</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.UsageScenarioImpl <em>Usage Scenario</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.UsageScenarioImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getUsageScenario()
	 * @generated
	 */
	int USAGE_SCENARIO = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Usage Model</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO__USAGE_MODEL = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Scenario Behavior</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO__SCENARIO_BEHAVIOR = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Workload Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO__WORKLOAD_TYPE = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Usage Scenario</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.ScenarioBehaviorImpl <em>Scenario Behavior</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.ScenarioBehaviorImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getScenarioBehavior()
	 * @generated
	 */
	int SCENARIO_BEHAVIOR = 2;

	/**
	 * The feature id for the '<em><b>Actions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCENARIO_BEHAVIOR__ACTIONS = 0;

	/**
	 * The number of structural features of the '<em>Scenario Behavior</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCENARIO_BEHAVIOR_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.WorkloadTypeImpl <em>Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadTypeImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getWorkloadType()
	 * @generated
	 */
	int WORKLOAD_TYPE = 3;

	/**
	 * The feature id for the '<em><b>Usage Scenario</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_TYPE__USAGE_SCENARIO = 0;

	/**
	 * The number of structural features of the '<em>Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.OpenWorkloadTypeImpl <em>Open Workload Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.OpenWorkloadTypeImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getOpenWorkloadType()
	 * @generated
	 */
	int OPEN_WORKLOAD_TYPE = 4;

	/**
	 * The feature id for the '<em><b>Usage Scenario</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPEN_WORKLOAD_TYPE__USAGE_SCENARIO = WORKLOAD_TYPE__USAGE_SCENARIO;

	/**
	 * The feature id for the '<em><b>Inter Arrival Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME = WORKLOAD_TYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Open Workload Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPEN_WORKLOAD_TYPE_FEATURE_COUNT = WORKLOAD_TYPE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.ClosedWorkloadTypeImpl <em>Closed Workload Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.ClosedWorkloadTypeImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getClosedWorkloadType()
	 * @generated
	 */
	int CLOSED_WORKLOAD_TYPE = 5;

	/**
	 * The feature id for the '<em><b>Usage Scenario</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOSED_WORKLOAD_TYPE__USAGE_SCENARIO = WORKLOAD_TYPE__USAGE_SCENARIO;

	/**
	 * The feature id for the '<em><b>Population</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOSED_WORKLOAD_TYPE__POPULATION = WORKLOAD_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Think Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOSED_WORKLOAD_TYPE__THINK_TIME = WORKLOAD_TYPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Closed Workload Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOSED_WORKLOAD_TYPE_FEATURE_COUNT = WORKLOAD_TYPE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.AbstractUserActionImpl <em>Abstract User Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.AbstractUserActionImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getAbstractUserAction()
	 * @generated
	 */
	int ABSTRACT_USER_ACTION = 6;

	/**
	 * The feature id for the '<em><b>Parent Scenario Behavior</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR = 0;

	/**
	 * The number of structural features of the '<em>Abstract User Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_USER_ACTION_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.LoopUserActionImpl <em>Loop User Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.LoopUserActionImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getLoopUserAction()
	 * @generated
	 */
	int LOOP_USER_ACTION = 7;

	/**
	 * The feature id for the '<em><b>Parent Scenario Behavior</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_USER_ACTION__PARENT_SCENARIO_BEHAVIOR = ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Loop Body Scenario Behavior</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR = ABSTRACT_USER_ACTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Loop Iteration Count</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_USER_ACTION__LOOP_ITERATION_COUNT = ABSTRACT_USER_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Loop User Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_USER_ACTION_FEATURE_COUNT = ABSTRACT_USER_ACTION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.DelayUserActionImpl <em>Delay User Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.DelayUserActionImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getDelayUserAction()
	 * @generated
	 */
	int DELAY_USER_ACTION = 8;

	/**
	 * The feature id for the '<em><b>Parent Scenario Behavior</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY_USER_ACTION__PARENT_SCENARIO_BEHAVIOR = ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Time Specification</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY_USER_ACTION__TIME_SPECIFICATION = ABSTRACT_USER_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Delay User Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY_USER_ACTION_FEATURE_COUNT = ABSTRACT_USER_ACTION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.BranchUserActionImpl <em>Branch User Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.BranchUserActionImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getBranchUserAction()
	 * @generated
	 */
	int BRANCH_USER_ACTION = 9;

	/**
	 * The feature id for the '<em><b>Parent Scenario Behavior</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_USER_ACTION__PARENT_SCENARIO_BEHAVIOR = ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Branches</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_USER_ACTION__BRANCHES = ABSTRACT_USER_ACTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Branch User Probabilities</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES = ABSTRACT_USER_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Branch User Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_USER_ACTION_FEATURE_COUNT = ABSTRACT_USER_ACTION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.EntryLevelSystemCallImpl <em>Entry Level System Call</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.EntryLevelSystemCallImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getEntryLevelSystemCall()
	 * @generated
	 */
	int ENTRY_LEVEL_SYSTEM_CALL = 10;

	/**
	 * The feature id for the '<em><b>Parent Scenario Behavior</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTRY_LEVEL_SYSTEM_CALL__PARENT_SCENARIO_BEHAVIOR = ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTRY_LEVEL_SYSTEM_CALL__PROVIDING_ROLE = ABSTRACT_USER_ACTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTRY_LEVEL_SYSTEM_CALL__SIGNATURE = ABSTRACT_USER_ACTION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Input Parameter Settings</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTRY_LEVEL_SYSTEM_CALL__INPUT_PARAMETER_SETTINGS = ABSTRACT_USER_ACTION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Entry Level System Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTRY_LEVEL_SYSTEM_CALL_FEATURE_COUNT = ABSTRACT_USER_ACTION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.workload.impl.CallParameterSettingImpl <em>Call Parameter Setting</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.workload.impl.CallParameterSettingImpl
	 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getCallParameterSetting()
	 * @generated
	 */
	int CALL_PARAMETER_SETTING = 11;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER_SETTING__NAME = 0;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER_SETTING__CHARACTERIZATION = 1;

	/**
	 * The feature id for the '<em><b>Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER_SETTING__VALUE = 2;

	/**
	 * The number of structural features of the '<em>Call Parameter Setting</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER_SETTING_FEATURE_COUNT = 3;


	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.Workload <em>Workload</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Workload</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.Workload
	 * @generated
	 */
	EClass getWorkload();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.workload.Workload#getSystem <em>System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>System</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.Workload#getSystem()
	 * @see #getWorkload()
	 * @generated
	 */
	EReference getWorkload_System();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.workload.Workload#getUsageScenarios <em>Usage Scenarios</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Usage Scenarios</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.Workload#getUsageScenarios()
	 * @see #getWorkload()
	 * @generated
	 */
	EReference getWorkload_UsageScenarios();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.UsageScenario <em>Usage Scenario</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Usage Scenario</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.UsageScenario
	 * @generated
	 */
	EClass getUsageScenario();

	/**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.workload.UsageScenario#getUsageModel <em>Usage Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Usage Model</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.UsageScenario#getUsageModel()
	 * @see #getUsageScenario()
	 * @generated
	 */
	EReference getUsageScenario_UsageModel();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.workload.UsageScenario#getScenarioBehavior <em>Scenario Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Scenario Behavior</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.UsageScenario#getScenarioBehavior()
	 * @see #getUsageScenario()
	 * @generated
	 */
	EReference getUsageScenario_ScenarioBehavior();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.workload.UsageScenario#getWorkloadType <em>Workload Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Workload Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.UsageScenario#getWorkloadType()
	 * @see #getUsageScenario()
	 * @generated
	 */
	EReference getUsageScenario_WorkloadType();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.ScenarioBehavior <em>Scenario Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scenario Behavior</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.ScenarioBehavior
	 * @generated
	 */
	EClass getScenarioBehavior();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.workload.ScenarioBehavior#getActions <em>Actions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Actions</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.ScenarioBehavior#getActions()
	 * @see #getScenarioBehavior()
	 * @generated
	 */
	EReference getScenarioBehavior_Actions();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.WorkloadType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.WorkloadType
	 * @generated
	 */
	EClass getWorkloadType();

	/**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.workload.WorkloadType#getUsageScenario <em>Usage Scenario</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Usage Scenario</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.WorkloadType#getUsageScenario()
	 * @see #getWorkloadType()
	 * @generated
	 */
	EReference getWorkloadType_UsageScenario();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.OpenWorkloadType <em>Open Workload Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Open Workload Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.OpenWorkloadType
	 * @generated
	 */
	EClass getOpenWorkloadType();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.workload.OpenWorkloadType#getInterArrivalTime <em>Inter Arrival Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Inter Arrival Time</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.OpenWorkloadType#getInterArrivalTime()
	 * @see #getOpenWorkloadType()
	 * @generated
	 */
	EReference getOpenWorkloadType_InterArrivalTime();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.ClosedWorkloadType <em>Closed Workload Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Closed Workload Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.ClosedWorkloadType
	 * @generated
	 */
	EClass getClosedWorkloadType();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.workload.ClosedWorkloadType#getPopulation <em>Population</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Population</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.ClosedWorkloadType#getPopulation()
	 * @see #getClosedWorkloadType()
	 * @generated
	 */
	EAttribute getClosedWorkloadType_Population();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.workload.ClosedWorkloadType#getThinkTime <em>Think Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Think Time</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.ClosedWorkloadType#getThinkTime()
	 * @see #getClosedWorkloadType()
	 * @generated
	 */
	EReference getClosedWorkloadType_ThinkTime();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.AbstractUserAction <em>Abstract User Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract User Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.AbstractUserAction
	 * @generated
	 */
	EClass getAbstractUserAction();

	/**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.workload.AbstractUserAction#getParentScenarioBehavior <em>Parent Scenario Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent Scenario Behavior</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.AbstractUserAction#getParentScenarioBehavior()
	 * @see #getAbstractUserAction()
	 * @generated
	 */
	EReference getAbstractUserAction_ParentScenarioBehavior();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.LoopUserAction <em>Loop User Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop User Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.LoopUserAction
	 * @generated
	 */
	EClass getLoopUserAction();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.workload.LoopUserAction#getLoopBodyScenarioBehavior <em>Loop Body Scenario Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Loop Body Scenario Behavior</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.LoopUserAction#getLoopBodyScenarioBehavior()
	 * @see #getLoopUserAction()
	 * @generated
	 */
	EReference getLoopUserAction_LoopBodyScenarioBehavior();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.workload.LoopUserAction#getLoopIterationCount <em>Loop Iteration Count</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Loop Iteration Count</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.LoopUserAction#getLoopIterationCount()
	 * @see #getLoopUserAction()
	 * @generated
	 */
	EReference getLoopUserAction_LoopIterationCount();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.DelayUserAction <em>Delay User Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Delay User Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.DelayUserAction
	 * @generated
	 */
	EClass getDelayUserAction();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.workload.DelayUserAction#getTimeSpecification <em>Time Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Time Specification</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.DelayUserAction#getTimeSpecification()
	 * @see #getDelayUserAction()
	 * @generated
	 */
	EReference getDelayUserAction_TimeSpecification();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.BranchUserAction <em>Branch User Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Branch User Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.BranchUserAction
	 * @generated
	 */
	EClass getBranchUserAction();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.workload.BranchUserAction#getBranches <em>Branches</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Branches</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.BranchUserAction#getBranches()
	 * @see #getBranchUserAction()
	 * @generated
	 */
	EReference getBranchUserAction_Branches();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.workload.BranchUserAction#getBranchUserProbabilities <em>Branch User Probabilities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Branch User Probabilities</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.BranchUserAction#getBranchUserProbabilities()
	 * @see #getBranchUserAction()
	 * @generated
	 */
	EReference getBranchUserAction_BranchUserProbabilities();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.EntryLevelSystemCall <em>Entry Level System Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Entry Level System Call</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.EntryLevelSystemCall
	 * @generated
	 */
	EClass getEntryLevelSystemCall();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.workload.EntryLevelSystemCall#getProvidingRole <em>Providing Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Providing Role</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.EntryLevelSystemCall#getProvidingRole()
	 * @see #getEntryLevelSystemCall()
	 * @generated
	 */
	EReference getEntryLevelSystemCall_ProvidingRole();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.workload.EntryLevelSystemCall#getSignature <em>Signature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Signature</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.EntryLevelSystemCall#getSignature()
	 * @see #getEntryLevelSystemCall()
	 * @generated
	 */
	EReference getEntryLevelSystemCall_Signature();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.workload.EntryLevelSystemCall#getInputParameterSettings <em>Input Parameter Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Input Parameter Settings</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.EntryLevelSystemCall#getInputParameterSettings()
	 * @see #getEntryLevelSystemCall()
	 * @generated
	 */
	EReference getEntryLevelSystemCall_InputParameterSettings();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.workload.CallParameterSetting <em>Call Parameter Setting</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Parameter Setting</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.CallParameterSetting
	 * @generated
	 */
	EClass getCallParameterSetting();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.workload.CallParameterSetting#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.CallParameterSetting#getName()
	 * @see #getCallParameterSetting()
	 * @generated
	 */
	EAttribute getCallParameterSetting_Name();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.workload.CallParameterSetting#getCharacterization <em>Characterization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Characterization</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.CallParameterSetting#getCharacterization()
	 * @see #getCallParameterSetting()
	 * @generated
	 */
	EAttribute getCallParameterSetting_Characterization();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.workload.CallParameterSetting#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.workload.CallParameterSetting#getValue()
	 * @see #getCallParameterSetting()
	 * @generated
	 */
	EReference getCallParameterSetting_Value();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	WorkloadFactory getWorkloadFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.WorkloadImpl <em>Workload</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getWorkload()
		 * @generated
		 */
		EClass WORKLOAD = eINSTANCE.getWorkload();

		/**
		 * The meta object literal for the '<em><b>System</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference WORKLOAD__SYSTEM = eINSTANCE.getWorkload_System();

		/**
		 * The meta object literal for the '<em><b>Usage Scenarios</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference WORKLOAD__USAGE_SCENARIOS = eINSTANCE.getWorkload_UsageScenarios();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.UsageScenarioImpl <em>Usage Scenario</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.UsageScenarioImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getUsageScenario()
		 * @generated
		 */
		EClass USAGE_SCENARIO = eINSTANCE.getUsageScenario();

		/**
		 * The meta object literal for the '<em><b>Usage Model</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference USAGE_SCENARIO__USAGE_MODEL = eINSTANCE.getUsageScenario_UsageModel();

		/**
		 * The meta object literal for the '<em><b>Scenario Behavior</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference USAGE_SCENARIO__SCENARIO_BEHAVIOR = eINSTANCE.getUsageScenario_ScenarioBehavior();

		/**
		 * The meta object literal for the '<em><b>Workload Type</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference USAGE_SCENARIO__WORKLOAD_TYPE = eINSTANCE.getUsageScenario_WorkloadType();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.ScenarioBehaviorImpl <em>Scenario Behavior</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.ScenarioBehaviorImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getScenarioBehavior()
		 * @generated
		 */
		EClass SCENARIO_BEHAVIOR = eINSTANCE.getScenarioBehavior();

		/**
		 * The meta object literal for the '<em><b>Actions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCENARIO_BEHAVIOR__ACTIONS = eINSTANCE.getScenarioBehavior_Actions();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.WorkloadTypeImpl <em>Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadTypeImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getWorkloadType()
		 * @generated
		 */
		EClass WORKLOAD_TYPE = eINSTANCE.getWorkloadType();

		/**
		 * The meta object literal for the '<em><b>Usage Scenario</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference WORKLOAD_TYPE__USAGE_SCENARIO = eINSTANCE.getWorkloadType_UsageScenario();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.OpenWorkloadTypeImpl <em>Open Workload Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.OpenWorkloadTypeImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getOpenWorkloadType()
		 * @generated
		 */
		EClass OPEN_WORKLOAD_TYPE = eINSTANCE.getOpenWorkloadType();

		/**
		 * The meta object literal for the '<em><b>Inter Arrival Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME = eINSTANCE.getOpenWorkloadType_InterArrivalTime();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.ClosedWorkloadTypeImpl <em>Closed Workload Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.ClosedWorkloadTypeImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getClosedWorkloadType()
		 * @generated
		 */
		EClass CLOSED_WORKLOAD_TYPE = eINSTANCE.getClosedWorkloadType();

		/**
		 * The meta object literal for the '<em><b>Population</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CLOSED_WORKLOAD_TYPE__POPULATION = eINSTANCE.getClosedWorkloadType_Population();

		/**
		 * The meta object literal for the '<em><b>Think Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CLOSED_WORKLOAD_TYPE__THINK_TIME = eINSTANCE.getClosedWorkloadType_ThinkTime();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.AbstractUserActionImpl <em>Abstract User Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.AbstractUserActionImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getAbstractUserAction()
		 * @generated
		 */
		EClass ABSTRACT_USER_ACTION = eINSTANCE.getAbstractUserAction();

		/**
		 * The meta object literal for the '<em><b>Parent Scenario Behavior</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR = eINSTANCE.getAbstractUserAction_ParentScenarioBehavior();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.LoopUserActionImpl <em>Loop User Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.LoopUserActionImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getLoopUserAction()
		 * @generated
		 */
		EClass LOOP_USER_ACTION = eINSTANCE.getLoopUserAction();

		/**
		 * The meta object literal for the '<em><b>Loop Body Scenario Behavior</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR = eINSTANCE.getLoopUserAction_LoopBodyScenarioBehavior();

		/**
		 * The meta object literal for the '<em><b>Loop Iteration Count</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_USER_ACTION__LOOP_ITERATION_COUNT = eINSTANCE.getLoopUserAction_LoopIterationCount();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.DelayUserActionImpl <em>Delay User Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.DelayUserActionImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getDelayUserAction()
		 * @generated
		 */
		EClass DELAY_USER_ACTION = eINSTANCE.getDelayUserAction();

		/**
		 * The meta object literal for the '<em><b>Time Specification</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DELAY_USER_ACTION__TIME_SPECIFICATION = eINSTANCE.getDelayUserAction_TimeSpecification();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.BranchUserActionImpl <em>Branch User Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.BranchUserActionImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getBranchUserAction()
		 * @generated
		 */
		EClass BRANCH_USER_ACTION = eINSTANCE.getBranchUserAction();

		/**
		 * The meta object literal for the '<em><b>Branches</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BRANCH_USER_ACTION__BRANCHES = eINSTANCE.getBranchUserAction_Branches();

		/**
		 * The meta object literal for the '<em><b>Branch User Probabilities</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES = eINSTANCE.getBranchUserAction_BranchUserProbabilities();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.EntryLevelSystemCallImpl <em>Entry Level System Call</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.EntryLevelSystemCallImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getEntryLevelSystemCall()
		 * @generated
		 */
		EClass ENTRY_LEVEL_SYSTEM_CALL = eINSTANCE.getEntryLevelSystemCall();

		/**
		 * The meta object literal for the '<em><b>Providing Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTRY_LEVEL_SYSTEM_CALL__PROVIDING_ROLE = eINSTANCE.getEntryLevelSystemCall_ProvidingRole();

		/**
		 * The meta object literal for the '<em><b>Signature</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTRY_LEVEL_SYSTEM_CALL__SIGNATURE = eINSTANCE.getEntryLevelSystemCall_Signature();

		/**
		 * The meta object literal for the '<em><b>Input Parameter Settings</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTRY_LEVEL_SYSTEM_CALL__INPUT_PARAMETER_SETTINGS = eINSTANCE.getEntryLevelSystemCall_InputParameterSettings();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.workload.impl.CallParameterSettingImpl <em>Call Parameter Setting</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.workload.impl.CallParameterSettingImpl
		 * @see edu.kit.ipd.descartes.mm.workload.impl.WorkloadPackageImpl#getCallParameterSetting()
		 * @generated
		 */
		EClass CALL_PARAMETER_SETTING = eINSTANCE.getCallParameterSetting();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL_PARAMETER_SETTING__NAME = eINSTANCE.getCallParameterSetting_Name();

		/**
		 * The meta object literal for the '<em><b>Characterization</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL_PARAMETER_SETTING__CHARACTERIZATION = eINSTANCE.getCallParameterSetting_Characterization();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL_PARAMETER_SETTING__VALUE = eINSTANCE.getCallParameterSetting_Value();

	}

} //WorkloadPackage
