/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.workload.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable;

import edu.kit.ipd.descartes.mm.workload.OpenWorkloadType;
import edu.kit.ipd.descartes.mm.workload.WorkloadPackage;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Open Workload Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.workload.impl.OpenWorkloadTypeImpl#getInterArrivalTime <em>Inter Arrival Time</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class OpenWorkloadTypeImpl extends WorkloadTypeImpl implements OpenWorkloadType {
	/**
	 * The cached value of the '{@link #getInterArrivalTime() <em>Inter Arrival Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterArrivalTime()
	 * @generated
	 * @ordered
	 */
	protected RandomVariable interArrivalTime;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OpenWorkloadTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return WorkloadPackage.Literals.OPEN_WORKLOAD_TYPE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RandomVariable getInterArrivalTime() {
		return interArrivalTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInterArrivalTime(RandomVariable newInterArrivalTime, NotificationChain msgs) {
		RandomVariable oldInterArrivalTime = interArrivalTime;
		interArrivalTime = newInterArrivalTime;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, WorkloadPackage.OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME, oldInterArrivalTime, newInterArrivalTime);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInterArrivalTime(RandomVariable newInterArrivalTime) {
		if (newInterArrivalTime != interArrivalTime) {
			NotificationChain msgs = null;
			if (interArrivalTime != null)
				msgs = ((InternalEObject)interArrivalTime).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - WorkloadPackage.OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME, null, msgs);
			if (newInterArrivalTime != null)
				msgs = ((InternalEObject)newInterArrivalTime).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - WorkloadPackage.OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME, null, msgs);
			msgs = basicSetInterArrivalTime(newInterArrivalTime, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorkloadPackage.OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME, newInterArrivalTime, newInterArrivalTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorkloadPackage.OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME:
				return basicSetInterArrivalTime(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case WorkloadPackage.OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME:
				return getInterArrivalTime();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case WorkloadPackage.OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME:
				setInterArrivalTime((RandomVariable)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case WorkloadPackage.OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME:
				setInterArrivalTime((RandomVariable)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case WorkloadPackage.OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME:
				return interArrivalTime != null;
		}
		return super.eIsSet(featureID);
	}

} //OpenWorkloadTypeImpl
