/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.workload.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.workload.UsageScenario;
import edu.kit.ipd.descartes.mm.workload.Workload;
import edu.kit.ipd.descartes.mm.workload.WorkloadPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Workload</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.workload.impl.WorkloadImpl#getSystem <em>System</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.workload.impl.WorkloadImpl#getUsageScenarios <em>Usage Scenarios</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class WorkloadImpl extends EntityImpl implements Workload {
	/**
	 * The cached value of the '{@link #getSystem() <em>System</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSystem()
	 * @generated
	 * @ordered
	 */
	protected edu.kit.ipd.descartes.mm.applicationlevel.system.System system;

	/**
	 * The cached value of the '{@link #getUsageScenarios() <em>Usage Scenarios</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUsageScenarios()
	 * @generated
	 * @ordered
	 */
	protected EList<UsageScenario> usageScenarios;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected WorkloadImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return WorkloadPackage.Literals.WORKLOAD;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public edu.kit.ipd.descartes.mm.applicationlevel.system.System getSystem() {
		if (system != null && system.eIsProxy()) {
			InternalEObject oldSystem = (InternalEObject)system;
			system = (edu.kit.ipd.descartes.mm.applicationlevel.system.System)eResolveProxy(oldSystem);
			if (system != oldSystem) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, WorkloadPackage.WORKLOAD__SYSTEM, oldSystem, system));
			}
		}
		return system;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public edu.kit.ipd.descartes.mm.applicationlevel.system.System basicGetSystem() {
		return system;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSystem(edu.kit.ipd.descartes.mm.applicationlevel.system.System newSystem) {
		edu.kit.ipd.descartes.mm.applicationlevel.system.System oldSystem = system;
		system = newSystem;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorkloadPackage.WORKLOAD__SYSTEM, oldSystem, system));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<UsageScenario> getUsageScenarios() {
		if (usageScenarios == null) {
			usageScenarios = new EObjectContainmentWithInverseEList<UsageScenario>(UsageScenario.class, this, WorkloadPackage.WORKLOAD__USAGE_SCENARIOS, WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL);
		}
		return usageScenarios;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorkloadPackage.WORKLOAD__USAGE_SCENARIOS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getUsageScenarios()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorkloadPackage.WORKLOAD__USAGE_SCENARIOS:
				return ((InternalEList<?>)getUsageScenarios()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case WorkloadPackage.WORKLOAD__SYSTEM:
				if (resolve) return getSystem();
				return basicGetSystem();
			case WorkloadPackage.WORKLOAD__USAGE_SCENARIOS:
				return getUsageScenarios();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case WorkloadPackage.WORKLOAD__SYSTEM:
				setSystem((edu.kit.ipd.descartes.mm.applicationlevel.system.System)newValue);
				return;
			case WorkloadPackage.WORKLOAD__USAGE_SCENARIOS:
				getUsageScenarios().clear();
				getUsageScenarios().addAll((Collection<? extends UsageScenario>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case WorkloadPackage.WORKLOAD__SYSTEM:
				setSystem((edu.kit.ipd.descartes.mm.applicationlevel.system.System)null);
				return;
			case WorkloadPackage.WORKLOAD__USAGE_SCENARIOS:
				getUsageScenarios().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case WorkloadPackage.WORKLOAD__SYSTEM:
				return system != null;
			case WorkloadPackage.WORKLOAD__USAGE_SCENARIOS:
				return usageScenarios != null && !usageScenarios.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //WorkloadImpl
