/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.workload.impl;

import edu.kit.ipd.descartes.core.CorePackage;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.FunctionsPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.system.SystemPackage;

import edu.kit.ipd.descartes.mm.workload.AbstractUserAction;
import edu.kit.ipd.descartes.mm.workload.BranchUserAction;
import edu.kit.ipd.descartes.mm.workload.CallParameterSetting;
import edu.kit.ipd.descartes.mm.workload.ClosedWorkloadType;
import edu.kit.ipd.descartes.mm.workload.DelayUserAction;
import edu.kit.ipd.descartes.mm.workload.EntryLevelSystemCall;
import edu.kit.ipd.descartes.mm.workload.LoopUserAction;
import edu.kit.ipd.descartes.mm.workload.OpenWorkloadType;
import edu.kit.ipd.descartes.mm.workload.ScenarioBehavior;
import edu.kit.ipd.descartes.mm.workload.UsageScenario;
import edu.kit.ipd.descartes.mm.workload.Workload;
import edu.kit.ipd.descartes.mm.workload.WorkloadFactory;
import edu.kit.ipd.descartes.mm.workload.WorkloadPackage;
import edu.kit.ipd.descartes.mm.workload.WorkloadType;

import edu.kit.ipd.descartes.mm.workload.util.WorkloadValidator;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class WorkloadPackageImpl extends EPackageImpl implements WorkloadPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass workloadEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass usageScenarioEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass scenarioBehaviorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass workloadTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass openWorkloadTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass closedWorkloadTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractUserActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass loopUserActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass delayUserActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass branchUserActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass entryLevelSystemCallEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callParameterSettingEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see edu.kit.ipd.descartes.mm.workload.WorkloadPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private WorkloadPackageImpl() {
		super(eNS_URI, WorkloadFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link WorkloadPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static WorkloadPackage init() {
		if (isInited) return (WorkloadPackage)EPackage.Registry.INSTANCE.getEPackage(WorkloadPackage.eNS_URI);

		// Obtain or create and register package
		WorkloadPackageImpl theWorkloadPackage = (WorkloadPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof WorkloadPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new WorkloadPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		FunctionsPackage.eINSTANCE.eClass();
		ParameterdependenciesPackage.eINSTANCE.eClass();
		RepositoryPackage.eINSTANCE.eClass();
		ServicebehaviorPackage.eINSTANCE.eClass();
		SystemPackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theWorkloadPackage.createPackageContents();

		// Initialize created meta-data
		theWorkloadPackage.initializePackageContents();

		// Register package validator
		EValidator.Registry.INSTANCE.put
			(theWorkloadPackage, 
			 new EValidator.Descriptor() {
				 public EValidator getEValidator() {
					 return WorkloadValidator.INSTANCE;
				 }
			 });

		// Mark meta-data to indicate it can't be changed
		theWorkloadPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(WorkloadPackage.eNS_URI, theWorkloadPackage);
		return theWorkloadPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getWorkload() {
		return workloadEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getWorkload_System() {
		return (EReference)workloadEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getWorkload_UsageScenarios() {
		return (EReference)workloadEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUsageScenario() {
		return usageScenarioEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUsageScenario_UsageModel() {
		return (EReference)usageScenarioEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUsageScenario_ScenarioBehavior() {
		return (EReference)usageScenarioEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUsageScenario_WorkloadType() {
		return (EReference)usageScenarioEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getScenarioBehavior() {
		return scenarioBehaviorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getScenarioBehavior_Actions() {
		return (EReference)scenarioBehaviorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getWorkloadType() {
		return workloadTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getWorkloadType_UsageScenario() {
		return (EReference)workloadTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOpenWorkloadType() {
		return openWorkloadTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getOpenWorkloadType_InterArrivalTime() {
		return (EReference)openWorkloadTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getClosedWorkloadType() {
		return closedWorkloadTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getClosedWorkloadType_Population() {
		return (EAttribute)closedWorkloadTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getClosedWorkloadType_ThinkTime() {
		return (EReference)closedWorkloadTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAbstractUserAction() {
		return abstractUserActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAbstractUserAction_ParentScenarioBehavior() {
		return (EReference)abstractUserActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLoopUserAction() {
		return loopUserActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoopUserAction_LoopBodyScenarioBehavior() {
		return (EReference)loopUserActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoopUserAction_LoopIterationCount() {
		return (EReference)loopUserActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDelayUserAction() {
		return delayUserActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDelayUserAction_TimeSpecification() {
		return (EReference)delayUserActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBranchUserAction() {
		return branchUserActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBranchUserAction_Branches() {
		return (EReference)branchUserActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBranchUserAction_BranchUserProbabilities() {
		return (EReference)branchUserActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEntryLevelSystemCall() {
		return entryLevelSystemCallEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEntryLevelSystemCall_ProvidingRole() {
		return (EReference)entryLevelSystemCallEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEntryLevelSystemCall_Signature() {
		return (EReference)entryLevelSystemCallEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEntryLevelSystemCall_InputParameterSettings() {
		return (EReference)entryLevelSystemCallEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCallParameterSetting() {
		return callParameterSettingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCallParameterSetting_Name() {
		return (EAttribute)callParameterSettingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCallParameterSetting_Characterization() {
		return (EAttribute)callParameterSettingEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCallParameterSetting_Value() {
		return (EReference)callParameterSettingEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WorkloadFactory getWorkloadFactory() {
		return (WorkloadFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		workloadEClass = createEClass(WORKLOAD);
		createEReference(workloadEClass, WORKLOAD__SYSTEM);
		createEReference(workloadEClass, WORKLOAD__USAGE_SCENARIOS);

		usageScenarioEClass = createEClass(USAGE_SCENARIO);
		createEReference(usageScenarioEClass, USAGE_SCENARIO__USAGE_MODEL);
		createEReference(usageScenarioEClass, USAGE_SCENARIO__SCENARIO_BEHAVIOR);
		createEReference(usageScenarioEClass, USAGE_SCENARIO__WORKLOAD_TYPE);

		scenarioBehaviorEClass = createEClass(SCENARIO_BEHAVIOR);
		createEReference(scenarioBehaviorEClass, SCENARIO_BEHAVIOR__ACTIONS);

		workloadTypeEClass = createEClass(WORKLOAD_TYPE);
		createEReference(workloadTypeEClass, WORKLOAD_TYPE__USAGE_SCENARIO);

		openWorkloadTypeEClass = createEClass(OPEN_WORKLOAD_TYPE);
		createEReference(openWorkloadTypeEClass, OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME);

		closedWorkloadTypeEClass = createEClass(CLOSED_WORKLOAD_TYPE);
		createEAttribute(closedWorkloadTypeEClass, CLOSED_WORKLOAD_TYPE__POPULATION);
		createEReference(closedWorkloadTypeEClass, CLOSED_WORKLOAD_TYPE__THINK_TIME);

		abstractUserActionEClass = createEClass(ABSTRACT_USER_ACTION);
		createEReference(abstractUserActionEClass, ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR);

		loopUserActionEClass = createEClass(LOOP_USER_ACTION);
		createEReference(loopUserActionEClass, LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR);
		createEReference(loopUserActionEClass, LOOP_USER_ACTION__LOOP_ITERATION_COUNT);

		delayUserActionEClass = createEClass(DELAY_USER_ACTION);
		createEReference(delayUserActionEClass, DELAY_USER_ACTION__TIME_SPECIFICATION);

		branchUserActionEClass = createEClass(BRANCH_USER_ACTION);
		createEReference(branchUserActionEClass, BRANCH_USER_ACTION__BRANCHES);
		createEReference(branchUserActionEClass, BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES);

		entryLevelSystemCallEClass = createEClass(ENTRY_LEVEL_SYSTEM_CALL);
		createEReference(entryLevelSystemCallEClass, ENTRY_LEVEL_SYSTEM_CALL__PROVIDING_ROLE);
		createEReference(entryLevelSystemCallEClass, ENTRY_LEVEL_SYSTEM_CALL__SIGNATURE);
		createEReference(entryLevelSystemCallEClass, ENTRY_LEVEL_SYSTEM_CALL__INPUT_PARAMETER_SETTINGS);

		callParameterSettingEClass = createEClass(CALL_PARAMETER_SETTING);
		createEAttribute(callParameterSettingEClass, CALL_PARAMETER_SETTING__NAME);
		createEAttribute(callParameterSettingEClass, CALL_PARAMETER_SETTING__CHARACTERIZATION);
		createEReference(callParameterSettingEClass, CALL_PARAMETER_SETTING__VALUE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		CorePackage theCorePackage = (CorePackage)EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI);
		SystemPackage theSystemPackage = (SystemPackage)EPackage.Registry.INSTANCE.getEPackage(SystemPackage.eNS_URI);
		FunctionsPackage theFunctionsPackage = (FunctionsPackage)EPackage.Registry.INSTANCE.getEPackage(FunctionsPackage.eNS_URI);
		RepositoryPackage theRepositoryPackage = (RepositoryPackage)EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI);
		ParameterdependenciesPackage theParameterdependenciesPackage = (ParameterdependenciesPackage)EPackage.Registry.INSTANCE.getEPackage(ParameterdependenciesPackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		workloadEClass.getESuperTypes().add(theCorePackage.getEntity());
		usageScenarioEClass.getESuperTypes().add(theCorePackage.getEntity());
		openWorkloadTypeEClass.getESuperTypes().add(this.getWorkloadType());
		closedWorkloadTypeEClass.getESuperTypes().add(this.getWorkloadType());
		loopUserActionEClass.getESuperTypes().add(this.getAbstractUserAction());
		delayUserActionEClass.getESuperTypes().add(this.getAbstractUserAction());
		branchUserActionEClass.getESuperTypes().add(this.getAbstractUserAction());
		entryLevelSystemCallEClass.getESuperTypes().add(this.getAbstractUserAction());

		// Initialize classes and features; add operations and parameters
		initEClass(workloadEClass, Workload.class, "Workload", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getWorkload_System(), theSystemPackage.getSystem(), null, "system", null, 0, 1, Workload.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getWorkload_UsageScenarios(), this.getUsageScenario(), this.getUsageScenario_UsageModel(), "usageScenarios", null, 0, -1, Workload.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(usageScenarioEClass, UsageScenario.class, "UsageScenario", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getUsageScenario_UsageModel(), this.getWorkload(), this.getWorkload_UsageScenarios(), "usageModel", null, 1, 1, UsageScenario.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getUsageScenario_ScenarioBehavior(), this.getScenarioBehavior(), null, "scenarioBehavior", null, 1, 1, UsageScenario.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getUsageScenario_WorkloadType(), this.getWorkloadType(), this.getWorkloadType_UsageScenario(), "workloadType", null, 1, 1, UsageScenario.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(scenarioBehaviorEClass, ScenarioBehavior.class, "ScenarioBehavior", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getScenarioBehavior_Actions(), this.getAbstractUserAction(), this.getAbstractUserAction_ParentScenarioBehavior(), "actions", null, 0, -1, ScenarioBehavior.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(workloadTypeEClass, WorkloadType.class, "WorkloadType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getWorkloadType_UsageScenario(), this.getUsageScenario(), this.getUsageScenario_WorkloadType(), "usageScenario", null, 1, 1, WorkloadType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(openWorkloadTypeEClass, OpenWorkloadType.class, "OpenWorkloadType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getOpenWorkloadType_InterArrivalTime(), theFunctionsPackage.getRandomVariable(), null, "interArrivalTime", null, 1, 1, OpenWorkloadType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(closedWorkloadTypeEClass, ClosedWorkloadType.class, "ClosedWorkloadType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getClosedWorkloadType_Population(), ecorePackage.getEBigInteger(), "population", null, 1, 1, ClosedWorkloadType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getClosedWorkloadType_ThinkTime(), theFunctionsPackage.getRandomVariable(), null, "thinkTime", null, 1, 1, ClosedWorkloadType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(abstractUserActionEClass, AbstractUserAction.class, "AbstractUserAction", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAbstractUserAction_ParentScenarioBehavior(), this.getScenarioBehavior(), this.getScenarioBehavior_Actions(), "parentScenarioBehavior", null, 1, 1, AbstractUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(loopUserActionEClass, LoopUserAction.class, "LoopUserAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLoopUserAction_LoopBodyScenarioBehavior(), this.getScenarioBehavior(), null, "loopBodyScenarioBehavior", null, 1, 1, LoopUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getLoopUserAction_LoopIterationCount(), theFunctionsPackage.getRandomVariable(), null, "loopIterationCount", null, 1, 1, LoopUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(delayUserActionEClass, DelayUserAction.class, "DelayUserAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDelayUserAction_TimeSpecification(), theFunctionsPackage.getRandomVariable(), null, "timeSpecification", null, 1, 1, DelayUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(branchUserActionEClass, BranchUserAction.class, "BranchUserAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBranchUserAction_Branches(), this.getScenarioBehavior(), null, "branches", null, 0, -1, BranchUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBranchUserAction_BranchUserProbabilities(), theFunctionsPackage.getRandomVariable(), null, "branchUserProbabilities", null, 1, 1, BranchUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(entryLevelSystemCallEClass, EntryLevelSystemCall.class, "EntryLevelSystemCall", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEntryLevelSystemCall_ProvidingRole(), theRepositoryPackage.getInterfaceProvidingRole(), null, "providingRole", null, 1, 1, EntryLevelSystemCall.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getEntryLevelSystemCall_Signature(), theRepositoryPackage.getSignature(), null, "signature", null, 1, 1, EntryLevelSystemCall.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getEntryLevelSystemCall_InputParameterSettings(), this.getCallParameterSetting(), null, "inputParameterSettings", null, 0, -1, EntryLevelSystemCall.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(callParameterSettingEClass, CallParameterSetting.class, "CallParameterSetting", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCallParameterSetting_Name(), ecorePackage.getEString(), "name", null, 1, 1, CallParameterSetting.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getCallParameterSetting_Characterization(), theParameterdependenciesPackage.getParameterCharacterizationType(), "characterization", "VALUE", 1, 1, CallParameterSetting.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getCallParameterSetting_Value(), theFunctionsPackage.getRandomVariable(), null, "value", null, 1, 1, CallParameterSetting.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http://www.eclipse.org/emf/2002/Ecore
		createEcoreAnnotations();
		// http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot
		createPivotAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createEcoreAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore";		
		addAnnotation
		  (this, 
		   source, 
		   new String[] {
			 "invocationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
			 "settingDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
			 "validationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot"
		   });		
		addAnnotation
		  (openWorkloadTypeEClass, 
		   source, 
		   new String[] {
			 "constraints", "interArrivalTimeInOpenWorkloadNeedsToBeSpecified"
		   });			
		addAnnotation
		  (closedWorkloadTypeEClass, 
		   source, 
		   new String[] {
			 "constraints", "thinkTimeInClosedWorkloadNeedsToBeSpecified populationInClosedWorkloadNeedsToBeGreaterThanZero"
		   });	
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createPivotAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot";				
		addAnnotation
		  (openWorkloadTypeEClass, 
		   source, 
		   new String[] {
			 "interArrivalTimeInOpenWorkloadNeedsToBeSpecified", "not self.interArrivalTime.oclIsUndefined() and not self.interArrivalTime.probFunction.oclIsUndefined()"
		   });			
		addAnnotation
		  (closedWorkloadTypeEClass, 
		   source, 
		   new String[] {
			 "thinkTimeInClosedWorkloadNeedsToBeSpecified", "not self.thinkTime.oclIsUndefined() and not self.thinkTime.probFunction.oclIsUndefined()",
			 "populationInClosedWorkloadNeedsToBeGreaterThanZero", "self.population > 0"
		   });
	}

} //WorkloadPackageImpl
